unit AlsaDemo1;

// 02. Nov 2020
// © winni
// GPL
// little Demo for alsa_sound unit

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
	 ExtCtrls,math, alsa_sound;

type

	 { TForm1 }

   TForm1 = class(TForm)
			Button1: TButton;
			ExitApp: TButton;
			Flanger: TButton;
			BeepMono: TButton;
			BeepWarble: TButton;
			BeepStereo: TButton;
			Silence: TButton;
			Glide: TButton;
			Germany: TButton;
			Swiss: TButton;
      Mexico: TButton;
			Image1: TImage;
			Panel1: TPanel;
			RadioWave: TRadioGroup;
			RadioStereo: TRadioGroup;
			FreqBar: TTrackBar;
			VolBar: TTrackBar;
			DuraBar: TTrackBar;
	 procedure Button1Click(Sender: TObject);
   procedure MexicoClick(Sender: TObject);
      procedure ExitAppClick(Sender: TObject);
			procedure FlangerClick(Sender: TObject);
			procedure BeepMonoClick(Sender: TObject);
			procedure BeepWarbleClick(Sender: TObject);
			procedure BeepStereoClick(Sender: TObject);
			procedure SilenceClick(Sender: TObject);
			procedure GlideClick(Sender: TObject);
			procedure GermanyClick(Sender: TObject);
			procedure SwissClick(Sender: TObject);
			procedure FormCreate(Sender: TObject);
			procedure Panel1Paint(Sender: TObject);
      procedure GetParas;
      procedure TrackBarChange(Sender: TObject);
   private
   Frequency : Integer;
   Duration : Integer;
   Volume : Integer;

   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.GetParas;
var tmp: single;
begin
duration := DuraBar.Position;
volume := VolBar.Position;
tmp := (FreqBar.Position-16) /50;
Frequency := round(power(2,tmp+5)); // offset 32
end;

procedure TForm1.TrackBarChange(Sender: TObject);
begin
   GetParas;
end;

procedure TForm1.ExitAppClick(Sender: TObject);
begin
   close;
end;

procedure TForm1.MexicoClick(Sender: TObject);

begin
   RadioWave.ItemIndex := 2;
   Application.ProcessMessages;
   AlsaMexicanTruck(2,Volume,true);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   ALSAbeepModulate(frequency, duration, volume,5,2,true);
end;

procedure TForm1.FlangerClick(Sender: TObject);
begin
 ALSAbeepFlanger(Frequency,  Duration, Volume, false, RadioWave.ItemIndex, true);
end;

procedure TForm1.BeepMonoClick(Sender: TObject);
begin
 ALSAbeep(frequency, duration, volume, false,RadioWave.ItemIndex,true);
end;

procedure TForm1.BeepWarbleClick(Sender: TObject);
begin
  ALSAbeep(frequency, duration, volume, true,RadioWave.ItemIndex,true);
end;

procedure TForm1.BeepStereoClick(Sender: TObject);
var freq2 : Integer;
   begin
   case RadioStereo.ItemIndex of
   0:  Freq2 := frequency * 3 div 2; // Quint
   1:  Freq2 := frequency * 4 div 3; // Quart
   2:  Freq2 := Frequency * 6 div 5; // kleine Terz
   3:  Freq2 := Frequency * 16 div 15; // kleine Sekunde
	 end;
   ALSAbeepStereo(Frequency,freq2,duration, Volume, Volume, false, RadioWave.ItemIndex,false)
	 end;


procedure TForm1.SilenceClick(Sender: TObject);
begin
   ALSAbeep(frequency, 50, volume, false,RadioWave.ItemIndex,false);
   ALSAsilence(Duration,false);
   ALSAbeep(frequency, 50, volume, false,RadioWave.ItemIndex,true);
end;

procedure TForm1.GlideClick(Sender: TObject);
var freq2 : integer;
begin
  if frequency > 440 then freq2 := 50 else freq2 := frequency+600;
  ALSAglide(frequency,freq2,duration,volume,true);
end;

procedure TForm1.GermanyClick(Sender: TObject);
begin
   RadioWave.ItemIndex := 2;
   Application.ProcessMessages;
   ALSAambulance(3,volume, true);
end;

procedure TForm1.SwissClick(Sender: TObject);
begin
   RadioWave.ItemIndex := 2;
   Application.ProcessMessages;
   ALSAswissbus(3, Volume, true);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
GetParas;
//TrackBarChange(Nil);
end;

procedure TForm1.Panel1Paint(Sender: TObject);
var x,y,dx,v: integer;
    s: string;
begin
Panel1.Canvas.TextOut(5,5,'Frequency Hz');
Panel1.Canvas.TextOut(5,+5+VolBar.Top,'Volume %');
Panel1.Canvas.TextOut(5,+5+DuraBar.Top,'Duration ms');
// Frequency
x := 16;
v := 32;
repeat
Panel1.Canvas.Line (x,FreqBar.Height,x,FreqBar.Height + 10);
s := IntToStr(v);
dx := Panel1.Canvas.TextWidth(s) div 2;
Panel1.Canvas.TextOut(-dx+x,FreqBar.Height + 10, s);
v := v * 2;
inc(x,50);
until x > Panel1.Width;


// Volume
X := 16;
v := 0;
Y := VolBar.Height+VolBar.Top;
repeat
Panel1.Canvas.Line (x,y,x,y+ 10);
s := IntToStr(v)+'%';
dx := Panel1.Canvas.TextWidth(s) div 2;
if v = 100 then dx := dx+dx div 2;
Panel1.Canvas.TextOut(-dx+x,y + 10, s);
inc(v,10);
inc (x,47);
until x > Panel1.Width;

// Duration
X := 16;
v := 50;

Y := DuraBar.Height+DuraBar.Top;
repeat
Panel1.Canvas.Line (x,y,x,y+ 10);
s := IntToStr(v);
dx := Panel1.Canvas.TextWidth(s) div 2;
if v = 10000 then dx := dx+dx div 2;
Panel1.Canvas.TextOut(-dx+x,y + 10, s);
if v = 50 then v := 1000 else inc(v,1000);
inc (x,47);
until x > Panel1.Width;
end;


end.

